clear
clc

global Ir It Il Irl Itl Irt Asat etat_init vitesse_rotation altitude points_trace tau vitesse_angul_mini

global energie_zero mom_mgn_max K_beta K_stab q_ref temps_phase1

% *********************  CAS PARTICULIERS  ***********************
K_perturbation=1;      % 0 sans perturbation  1 avec perturbations
K_commande=1;          % 0 sans commande  1 avec commande
K_inertie=1;           % 0 diagonale   1 avec matrice relle
K_revolution=0;        % 0 pour une matrice d'inertie quelconque 1 pour une matrice de rvolution autour de y
K_repos=0;             % 0 pour le cas gnral et 1 pour le repos total
K_petit_cone=0;        % 0 pour le cas gnral et 1 pour un cne de Poinsot trs rduit
% ****************************************************************

vitesse_angul_mini=3e-3;   % Vitesse angulaire au dessous de laquelle on passe au mode fin

K_beta=0.5;% K_stab=2;     % Constantes de la rgulation

q_ref=-3*pi/180;           % -3/s pour la vitesse finale auitour de y

temps_phase1=25000;temps_phase2=6000;

mom_mgn_max=0.2;                       % Moment magntique maximum  ne pas dpasser

% Nombre de points du trac

 points_trace=40000;

% Matrice d''inertie satellite 
%	x=r=roulis
%	y=t=tangage
%	z=l=lacet

if K_inertie==0
  % Cas matrice diagonale
  Ir=22e-3;It=25e-3;Il=10e-3;Irt=0;Irl=0;Itl=0;
else
   % Cas gnral
   Ir=22e-3;It=25e-3;Il=10e-3;Irt=5.344e-5;Irl=-1.998e-4;Itl=9.839e-4;
end

if K_revolution==1
  % Cas matrice diagonale de rvolution spcialement choisie
  Ir=16e-3;It=25e-3;Il=16e-3;Irt=0;Irl=0;Itl=0;
else
   % Cas gnral
   Ir=22e-3;It=25e-3;Il=10e-3;Irt=5.344e-5;Irl=-1.998e-4;Itl=9.839e-4;
end

% *************************************

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% [V,D]=eig(Asat),

% Asat =[0.0220         0         0
%                0    0.0251         0
%                     0         0    0.0099]


% Caractristiques de l'orbite du satellite

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;

periode_orbitale=2*pi/vitesse_rotation;

%   **********  VALEURS INITIALES   ******

% Initialisation en vitesses (rd/s)

v_roulis0=0.06;
v_tangage0=0.05;
v_lacet0=0.01;

% Initialisation en vitesses moyennes (rd/s)

v_roulis0=0.1;
v_tangage0=0.2;
v_lacet0=-0.15;


% Initialisation en position (rd)

roulis0=0.1;
tangage0=-0.1;
lacet0=0.05;

if K_repos==1
  % Cas de Poinsot avec pointage initial idal au repos dans XYZ
  roulis0=0;tangage0=0;lacet0=0;
  v_roulis0=0;v_tangage0=0.1;v_lacet0=0;
end

if K_petit_cone==1
  % Cas de Poinsot avec pointage initial idal au repos dans XYZ et trs petite vitesse transverse
  % Cas matrice diagonale de rvolution spcialement choisie
  Ir=16e-3;It=25e-3;Il=16e-3;Irt=0;Irl=0;Itl=0;
  roulis0=0;tangage0=0;lacet0=0;
  v_roulis0=0.00524;v_tangage0=0.1;v_lacet0=0;
end

% ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;


% cpl_magn_res1=1.5e-7;cpl_magn_res2=1.5e-7;cpl_magn_res3=1.5e-7;  % COUPLE MAGNETIQUE RESIDUEL

% **********************************************************************

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********
% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   
energie_zero=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]';

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
Q=inv_quat(Pmat);

qt00=Q(1);qt10=Q(2);qt20=Q(3);qt30=Q(4);

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

end








